Index: uspace/drv/usbhid/multimedia/multimedia.c
===================================================================
--- uspace/drv/usbhid/multimedia/multimedia.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
+++ uspace/drv/usbhid/multimedia/multimedia.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -0,0 +1,378 @@
+/*
+ * Copyright (c) 2011 Lubos Slovak, Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbhid
+ * @{
+ */
+/**
+ * @file
+ * USB Keyboard multimedia keys subdriver.
+ */
+
+
+#include "multimedia.h"
+#include "../usbhid.h"
+#include "keymap.h"
+
+#include <usb/hid/hidparser.h>
+#include <usb/debug.h>
+#include <usb/hid/usages/core.h>
+
+#include <errno.h>
+#include <str_error.h>
+
+#include <ipc/kbd.h>
+#include <io/console.h>
+
+#define NAME "multimedia-keys"
+
+/*----------------------------------------------------------------------------*/
+/**
+ * Logitech UltraX device type.
+ */
+typedef struct usb_multimedia_t {
+	/** Previously pressed keys (not translated to key codes). */
+	int32_t *keys_old;
+	/** Currently pressed keys (not translated to key codes). */
+	int32_t *keys;
+	/** Count of stored keys (i.e. number of keys in the report). */
+	size_t key_count;	
+	/** IPC phone to the console device (for sending key events). */
+	int console_phone;
+} usb_multimedia_t;
+
+
+/*----------------------------------------------------------------------------*/
+/** 
+ * Default handler for IPC methods not handled by DDF.
+ *
+ * Currently recognizes only one method (IPC_M_CONNECT_TO_ME), in which case it
+ * assumes the caller is the console and thus it stores IPC phone to it for 
+ * later use by the driver to notify about key events.
+ *
+ * @param fun Device function handling the call.
+ * @param icallid Call id.
+ * @param icall Call data.
+ */
+static void default_connection_handler(ddf_fun_t *fun,
+    ipc_callid_t icallid, ipc_call_t *icall)
+{
+	usb_log_debug(NAME " default_connection_handler()\n");
+	
+	sysarg_t method = IPC_GET_IMETHOD(*icall);
+	
+	usb_multimedia_t *multim_dev = (usb_multimedia_t *)fun->driver_data;
+	//usb_hid_dev_t *hid_dev = (usb_hid_dev_t *)fun->driver_data;
+	
+	if (multim_dev == NULL) {
+		async_answer_0(icallid, EINVAL);
+		return;
+	}
+
+	if (method == IPC_M_CONNECT_TO_ME) {
+		int callback = IPC_GET_ARG5(*icall);
+
+		if (multim_dev->console_phone != -1) {
+			async_answer_0(icallid, ELIMIT);
+			return;
+		}
+
+		multim_dev->console_phone = callback;
+		usb_log_debug(NAME " Saved phone to console: %d\n", callback);
+		async_answer_0(icallid, EOK);
+		return;
+	}
+	
+	async_answer_0(icallid, EINVAL);
+}
+
+/*----------------------------------------------------------------------------*/
+
+static ddf_dev_ops_t multimedia_ops = {
+	.default_handler = default_connection_handler
+};
+
+/*----------------------------------------------------------------------------*/
+/**
+ * Processes key events.
+ *
+ * @note This function was copied from AT keyboard driver and modified to suit
+ *       USB keyboard.
+ *
+ * @note Lock keys are not sent to the console, as they are completely handled
+ *       in the driver. It may, however, be required later that the driver
+ *       sends also these keys to application (otherwise it cannot use those
+ *       keys at all).
+ * 
+ * @param hid_dev 
+ * @param lgtch_dev 
+ * @param type Type of the event (press / release). Recognized values: 
+ *             KEY_PRESS, KEY_RELEASE
+ * @param key Key code of the key according to HID Usage Tables.
+ */
+static void usb_multimedia_push_ev(usb_hid_dev_t *hid_dev, 
+    usb_multimedia_t *multim_dev, int type, unsigned int key)
+{
+	assert(hid_dev != NULL);
+	assert(multim_dev != NULL);
+	
+//	usb_multimedia_t *multim_dev = (usb_multimedia_t *)hid_dev->data;
+	
+	console_event_t ev;
+	
+	ev.type = type;
+	ev.key = key;
+	ev.mods = 0;
+	ev.c = 0;
+
+	usb_log_debug2(NAME " Sending key %d to the console\n", ev.key);
+	if (multim_dev->console_phone < 0) {
+		usb_log_warning(
+		    "Connection to console not ready, key discarded.\n");
+		return;
+	}
+	
+	async_msg_4(multim_dev->console_phone, KBD_EVENT, ev.type, ev.key, 
+	    ev.mods, ev.c);
+}
+
+/*----------------------------------------------------------------------------*/
+
+static void usb_multimedia_free(usb_multimedia_t **multim_dev)
+{
+	if (multim_dev == NULL || *multim_dev == NULL) {
+		return;
+	}
+	
+	// hangup phone to the console
+	async_hangup((*multim_dev)->console_phone);
+	
+	// free all buffers
+	if ((*multim_dev)->keys != NULL) {
+		free((*multim_dev)->keys);
+	}
+	if ((*multim_dev)->keys_old != NULL) {
+		free((*multim_dev)->keys_old);
+	}
+
+	free(*multim_dev);
+	*multim_dev = NULL;
+}
+
+/*----------------------------------------------------------------------------*/
+
+static int usb_multimedia_create_function(usb_hid_dev_t *hid_dev, 
+    usb_multimedia_t *multim_dev)
+{
+	/* Create the function exposed under /dev/devices. */
+	ddf_fun_t *fun = ddf_fun_create(hid_dev->usb_dev->ddf_dev, fun_exposed, 
+	    NAME);
+	if (fun == NULL) {
+		usb_log_error("Could not create DDF function node.\n");
+		return ENOMEM;
+	}
+	
+	fun->ops = &multimedia_ops;
+	fun->driver_data = multim_dev;   // TODO: maybe change to hid_dev->data
+	
+	int rc = ddf_fun_bind(fun);
+	if (rc != EOK) {
+		usb_log_error("Could not bind DDF function: %s.\n",
+		    str_error(rc));
+		// TODO: Can / should I destroy the DDF function?
+		ddf_fun_destroy(fun);
+		return rc;
+	}
+	
+	rc = ddf_fun_add_to_class(fun, "keyboard");
+	if (rc != EOK) {
+		usb_log_error(
+		    "Could not add DDF function to class 'keyboard': %s.\n",
+		    str_error(rc));
+		// TODO: Can / should I destroy the DDF function?
+		ddf_fun_destroy(fun);
+		return rc;
+	}
+	
+	return EOK;
+}
+
+/*----------------------------------------------------------------------------*/
+
+int usb_multimedia_init(struct usb_hid_dev *hid_dev, void **data)
+{
+	if (hid_dev == NULL || hid_dev->usb_dev == NULL) {
+		return EINVAL; /*! @todo Other return code? */
+	}
+	
+	usb_log_debug(NAME " Initializing HID/multimedia structure...\n");
+	
+	usb_multimedia_t *multim_dev = (usb_multimedia_t *)malloc(
+	    sizeof(usb_multimedia_t));
+	if (multim_dev == NULL) {
+		return ENOMEM;
+	}
+	
+	multim_dev->console_phone = -1;
+	
+	usb_hid_report_path_t *path = usb_hid_report_path();
+	usb_hid_report_path_append_item(path, USB_HIDUT_PAGE_CONSUMER, 0);
+	
+	usb_hid_report_path_set_report_id(path, 1);
+	
+	multim_dev->key_count = usb_hid_report_size(
+	    hid_dev->report, 0, USB_HID_REPORT_TYPE_INPUT);
+
+	usb_hid_report_path_free(path);
+	
+	usb_log_debug(NAME " Size of the input report: %zu\n", 
+	    multim_dev->key_count);
+	
+	multim_dev->keys = (int32_t *)calloc(multim_dev->key_count, 
+	    sizeof(int32_t));
+	
+	if (multim_dev->keys == NULL) {
+		usb_log_fatal("No memory!\n");
+		free(multim_dev);
+		return ENOMEM;
+	}
+	
+	multim_dev->keys_old = 
+		(int32_t *)calloc(multim_dev->key_count, sizeof(int32_t));
+	
+	if (multim_dev->keys_old == NULL) {
+		usb_log_fatal("No memory!\n");
+		free(multim_dev->keys);
+		free(multim_dev);
+		return ENOMEM;
+	}
+	
+	/*! @todo Autorepeat */
+	
+	// save the KBD device structure into the HID device structure
+	*data = multim_dev;
+	
+	usb_log_debug(NAME " HID/multimedia device structure initialized.\n");
+	
+	int rc = usb_multimedia_create_function(hid_dev, multim_dev);
+	if (rc != EOK) {
+		usb_multimedia_free(&multim_dev);
+		return rc;
+	}
+	
+	usb_log_debug(NAME " HID/multimedia structure initialized.\n");
+	
+	return EOK;
+}
+
+/*----------------------------------------------------------------------------*/
+
+void usb_multimedia_deinit(struct usb_hid_dev *hid_dev, void *data)
+{
+	if (hid_dev == NULL) {
+		return;
+	}
+	
+	if (data != NULL) {
+		usb_multimedia_t *multim_dev = (usb_multimedia_t *)data;
+		usb_multimedia_free(&multim_dev);
+	}
+}
+
+/*----------------------------------------------------------------------------*/
+
+bool usb_multimedia_polling_callback(struct usb_hid_dev *hid_dev, void *data, 
+    uint8_t *buffer, size_t buffer_size)
+{
+	// TODO: checks
+	
+	usb_log_debug(NAME " usb_lgtch_polling_callback(%p, %p, %zu)\n",
+	    hid_dev, buffer, buffer_size);
+	
+	if (data == NULL) {
+		return EINVAL;	// TODO: other error code?
+	}
+	
+	usb_multimedia_t *multim_dev = (usb_multimedia_t *)data;
+
+	usb_log_debug(NAME " Calling usb_hid_parse_report() with "
+	    "buffer %s\n", usb_debug_str_buffer(buffer, buffer_size, 0));
+	
+	usb_hid_report_path_t *path = usb_hid_report_path();
+	usb_hid_report_path_append_item(path, USB_HIDUT_PAGE_CONSUMER, 0);
+
+	uint8_t report_id;
+	
+	int rc = usb_hid_parse_report(hid_dev->report, buffer, buffer_size, 
+	    &report_id);
+	
+	if (rc != EOK) {
+		usb_log_warning(NAME "Error in usb_hid_parse_report(): %s\n", 
+		    str_error(rc));
+		return true;
+	}
+	
+	usb_hid_report_path_set_report_id(path, report_id);
+
+	usb_hid_report_field_t *field = usb_hid_report_get_sibling(
+	    hid_dev->report, NULL, path, USB_HID_PATH_COMPARE_END 
+	    | USB_HID_PATH_COMPARE_USAGE_PAGE_ONLY, 
+	    USB_HID_REPORT_TYPE_INPUT);
+	
+//	unsigned int key;
+	
+	/*! @todo Is this iterating OK if done multiple times? 
+	 *  @todo The parsing is not OK
+	 */
+	while (field != NULL) {
+		if(field->value != 0) {
+			usb_log_debug(NAME " KEY VALUE(%X) USAGE(%X)\n", 
+			    field->value, field->usage);
+			unsigned int key = 
+			    usb_multimedia_map_usage(field->usage);
+			const char *key_str = 
+			    usb_multimedia_usage_to_str(field->usage);
+			usb_log_info("Pressed key: %s\n", key_str);
+			usb_multimedia_push_ev(hid_dev, multim_dev, KEY_PRESS, 
+			                       key);
+		}
+		
+		field = usb_hid_report_get_sibling(
+		    hid_dev->report, field, path, USB_HID_PATH_COMPARE_END
+		    | USB_HID_PATH_COMPARE_USAGE_PAGE_ONLY, 
+		    USB_HID_REPORT_TYPE_INPUT);
+	}	
+
+	usb_hid_report_path_free(path);
+	
+	return true;
+}
+
+/**
+ * @}
+ */
Index: uspace/drv/usbhid/multimedia/multimedia.h
===================================================================
--- uspace/drv/usbhid/multimedia/multimedia.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
+++ uspace/drv/usbhid/multimedia/multimedia.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -0,0 +1,58 @@
+/*
+ * Copyright (c) 2011 Lubos Slovak
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup drvusbhid
+ * @{
+ */
+/** @file
+ * USB Keyboard multimedia keys subdriver.
+ */
+
+#ifndef USB_HID_MULTIMEDIA_H_
+#define USB_HID_MULTIMEDIA_H_
+
+#include <usb/dev/driver.h>
+
+struct usb_hid_dev;
+
+/*----------------------------------------------------------------------------*/
+
+int usb_multimedia_init(struct usb_hid_dev *hid_dev, void **data);
+
+void usb_multimedia_deinit(struct usb_hid_dev *hid_dev, void *data);
+
+bool usb_multimedia_polling_callback(struct usb_hid_dev *hid_dev, void *data,
+    uint8_t *buffer, size_t buffer_size);
+
+/*----------------------------------------------------------------------------*/
+
+#endif // USB_HID_MULTIMEDIA_H_
+
+/**
+ * @}
+ */
Index: uspace/drv/usbhid/subdrivers.c
===================================================================
--- uspace/drv/usbhid/subdrivers.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhid/subdrivers.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -35,22 +35,24 @@
 
 #include "subdrivers.h"
-#include "usb/classes/hidut.h"
-#include "usb/classes/hidpath.h"
+#include <usb/hid/usages/core.h>
+#include <usb/hid/hidpath.h>
 
-#include "lgtch-ultrax/lgtch-ultrax.h"
+//#include "lgtch-ultrax/lgtch-ultrax.h"
+#include "multimedia/multimedia.h"
 #include "mouse/mousedev.h"
 
 static usb_hid_subdriver_usage_t path_kbd[] = {
-	{USB_HIDUT_PAGE_KEYBOARD, 0}, 
+	{USB_HIDUT_PAGE_GENERIC_DESKTOP, 
+	 USB_HIDUT_USAGE_GENERIC_DESKTOP_KEYBOARD}, 
 	{0, 0}
 };
 
-static usb_hid_subdriver_usage_t path_mouse2[] = {
-	{USB_HIDUT_PAGE_GENERIC_DESKTOP, USB_HIDUT_USAGE_GENERIC_DESKTOP_X},
+static usb_hid_subdriver_usage_t path_mouse[] = {
+	{USB_HIDUT_PAGE_GENERIC_DESKTOP, USB_HIDUT_USAGE_GENERIC_DESKTOP_MOUSE},
 	{0, 0}
 };
 
-static usb_hid_subdriver_usage_t lgtch_path[] = {
-	{0xc, 0},
+static usb_hid_subdriver_usage_t multim_key_path[] = {
+	{USB_HIDUT_PAGE_CONSUMER, USB_HIDUT_USAGE_CONSUMER_CONSUMER_CONTROL},
 	{0, 0}
 };
@@ -60,6 +62,5 @@
 		path_kbd,
 		-1,
-		USB_HID_PATH_COMPARE_END 
-		| USB_HID_PATH_COMPARE_USAGE_PAGE_ONLY,
+		USB_HID_PATH_COMPARE_BEGIN,
 		-1,
 		-1,
@@ -73,22 +74,20 @@
 	},
 	{
-		lgtch_path,
+		multim_key_path,
 		1,
-		USB_HID_PATH_COMPARE_END 
-		| USB_HID_PATH_COMPARE_USAGE_PAGE_ONLY,
-		0x046d,
-		0xc30e,
+		USB_HID_PATH_COMPARE_BEGIN,
+		-1,
+		-1,
 		{
-			.init = usb_lgtch_init,
-			.deinit = usb_lgtch_deinit,
-			.poll = usb_lgtch_polling_callback,
+			.init = usb_multimedia_init,
+			.deinit = usb_multimedia_deinit,
+			.poll = usb_multimedia_polling_callback,
 			.poll_end = NULL
 		}
 	},
 	{
-		path_mouse2,
+		path_mouse,
 		-1,
-		USB_HID_PATH_COMPARE_END 
-		| USB_HID_PATH_COMPARE_USAGE_PAGE_ONLY,
+		USB_HID_PATH_COMPARE_BEGIN,
 		-1,
 		-1,
@@ -100,5 +99,5 @@
 		}
 	},
-	{NULL, -1, 0, -1, -1, {NULL, NULL, NULL, NULL}}
+	{NULL, -1, 0, -1, -1, {NULL, NULL, NULL, NULL, NULL}}
 };
 
Index: uspace/drv/usbhid/usbhid.c
===================================================================
--- uspace/drv/usbhid/usbhid.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhid/usbhid.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -37,8 +37,8 @@
 #include <usb/debug.h>
 #include <usb/classes/classes.h>
-#include <usb/classes/hid.h>
-#include <usb/classes/hidparser.h>
-#include <usb/classes/hidreport.h>
-#include <usb/classes/hidreq.h>
+#include <usb/hid/hid.h>
+#include <usb/hid/hidparser.h>
+#include <usb/hid/hidreport.h>
+#include <usb/hid/request.h>
 #include <errno.h>
 #include <str_error.h>
@@ -203,8 +203,17 @@
 	
 	usb_log_debug("Compare flags: %d\n", mapping->compare);
-	size_t size = usb_hid_report_input_length(hid_dev->report, usage_path, 
-	    mapping->compare);
+//	size_t size = usb_hid_report_size(hid_dev->report, 0, 
+//	    USB_HID_REPORT_TYPE_INPUT);
+	size_t size = 0;
+	usb_hid_report_field_t *field = usb_hid_report_get_sibling (hid_dev->report,
+		NULL, usage_path, mapping->compare, USB_HID_REPORT_TYPE_INPUT);
+	while(field != NULL) {
+		size++;
+		field = usb_hid_report_get_sibling (hid_dev->report,
+					field, usage_path, mapping->compare, 
+		            USB_HID_REPORT_TYPE_INPUT);
+	}
+	
 	usb_log_debug("Size of the input report: %zuB\n", size);
-	
 	usb_hid_report_path_free(usage_path);
 	
@@ -457,5 +466,6 @@
 			if (hid_dev->subdrivers[i].init != NULL) {
 				usb_log_debug("Initializing subdriver %d.\n",i);
-				rc = hid_dev->subdrivers[i].init(hid_dev);
+				rc = hid_dev->subdrivers[i].init(hid_dev,
+				    &hid_dev->subdrivers[i].data);
 				if (rc != EOK) {
 					usb_log_warning("Failed to initialize"
@@ -522,6 +532,6 @@
 	for (i = 0; i < hid_dev->subdriver_count; ++i) {
 		if (hid_dev->subdrivers[i].poll != NULL
-		    && hid_dev->subdrivers[i].poll(hid_dev, buffer, 
-		    buffer_size)) {
+		    && hid_dev->subdrivers[i].poll(hid_dev, 
+		        hid_dev->subdrivers[i].data, buffer, buffer_size)) {
 			cont = true;
 		}
@@ -546,5 +556,6 @@
 	for (i = 0; i < hid_dev->subdriver_count; ++i) {
 		if (hid_dev->subdrivers[i].poll_end != NULL) {
-			hid_dev->subdrivers[i].poll_end(hid_dev, reason);
+			hid_dev->subdrivers[i].poll_end(hid_dev,
+			    hid_dev->subdrivers[i].data, reason);
 		}
 	}
@@ -627,5 +638,6 @@
 	for (i = 0; i < (*hid_dev)->subdriver_count; ++i) {
 		if ((*hid_dev)->subdrivers[i].deinit != NULL) {
-			(*hid_dev)->subdrivers[i].deinit(*hid_dev);
+			(*hid_dev)->subdrivers[i].deinit(*hid_dev,
+			    (*hid_dev)->subdrivers[i].data);
 		}
 	}
Index: uspace/drv/usbhid/usbhid.h
===================================================================
--- uspace/drv/usbhid/usbhid.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhid/usbhid.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -39,17 +39,19 @@
 #include <stdint.h>
 
-#include <usb/classes/hidparser.h>
+#include <usb/hid/hidparser.h>
 #include <ddf/driver.h>
-#include <usb/pipes.h>
-#include <usb/devdrv.h>
-#include <usb/classes/hid.h>
+#include <usb/dev/pipes.h>
+#include <usb/dev/driver.h>
+#include <usb/hid/hid.h>
 #include <bool.h>
 
 struct usb_hid_dev;
 
-typedef int (*usb_hid_driver_init_t)(struct usb_hid_dev *);
-typedef void (*usb_hid_driver_deinit_t)(struct usb_hid_dev *);
-typedef bool (*usb_hid_driver_poll)(struct usb_hid_dev *, uint8_t *, size_t);
-typedef int (*usb_hid_driver_poll_ended)(struct usb_hid_dev *, bool reason);
+typedef int (*usb_hid_driver_init_t)(struct usb_hid_dev *, void **data);
+typedef void (*usb_hid_driver_deinit_t)(struct usb_hid_dev *, void *data);
+typedef bool (*usb_hid_driver_poll)(struct usb_hid_dev *, void *data, uint8_t *,
+                                    size_t);
+typedef int (*usb_hid_driver_poll_ended)(struct usb_hid_dev *, void *data, 
+                                         bool reason);
 
 // TODO: add function and class name??
@@ -63,4 +65,6 @@
 	/** Function to be called when polling ends. */
 	usb_hid_driver_poll_ended poll_end;
+	/** Arbitrary data needed by the subdriver. */
+	void *data;
 } usb_hid_subdriver_t;
 
@@ -72,7 +76,4 @@
 	/** Structure holding generic USB device information. */
 	usb_device_t *usb_dev;
-	
-	/** @todo What is this actually? */
-	ddf_dev_ops_t ops;
 	
 	/** Index of the polling pipe in usb_hid_endpoints array. */
@@ -97,7 +98,4 @@
 	
 	size_t input_report_size;
-	
-	/** Arbitrary data (e.g. a special structure for handling keyboard). */
-	void *data;
 } usb_hid_dev_t;
 
Index: uspace/drv/usbhub/main.c
===================================================================
--- uspace/drv/usbhub/main.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhub/main.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -36,5 +36,5 @@
 #include <stdio.h>
 
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 #include <usb/classes/classes.h>
 
Index: uspace/drv/usbhub/port_status.h
===================================================================
--- uspace/drv/usbhub/port_status.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhub/port_status.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -35,5 +35,5 @@
 #include <bool.h>
 #include <sys/types.h>
-#include <usb/request.h>
+#include <usb/dev/request.h>
 #include "usbhub_private.h"
 
Index: uspace/drv/usbhub/ports.h
===================================================================
--- uspace/drv/usbhub/ports.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhub/ports.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -36,6 +36,6 @@
 #define DRV_USBHUB_PORTS_H
 
-#include <usb/devdrv.h>
-#include <usb/hub.h>
+#include <usb/dev/driver.h>
+#include <usb/dev/hub.h>
 
 typedef struct usb_hub_info_t usb_hub_info_t;
Index: uspace/drv/usbhub/usbhub.c
===================================================================
--- uspace/drv/usbhub/usbhub.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhub/usbhub.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -42,8 +42,8 @@
 #include <usb/ddfiface.h>
 #include <usb/descriptor.h>
-#include <usb/recognise.h>
-#include <usb/request.h>
+#include <usb/dev/recognise.h>
+#include <usb/dev/request.h>
 #include <usb/classes/hub.h>
-#include <usb/devpoll.h>
+#include <usb/dev/poll.h>
 #include <stdio.h>
 
@@ -51,7 +51,7 @@
 #include "usbhub_private.h"
 #include "port_status.h"
-#include "usb/usb.h"
-#include "usb/pipes.h"
-#include "usb/classes/classes.h"
+#include <usb/usb.h>
+#include <usb/dev/pipes.h>
+#include <usb/classes/classes.h>
 
 
Index: uspace/drv/usbhub/usbhub.h
===================================================================
--- uspace/drv/usbhub/usbhub.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhub/usbhub.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -39,9 +39,9 @@
 #include <ddf/driver.h>
 
-#include <usb/hub.h>
+#include <usb/dev/hub.h>
 #include <usb/classes/hub.h>
 
-#include <usb/pipes.h>
-#include <usb/devdrv.h>
+#include <usb/dev/pipes.h>
+#include <usb/dev/driver.h>
 
 #include <fibril_synch.h>
Index: uspace/drv/usbhub/usbhub_private.h
===================================================================
--- uspace/drv/usbhub/usbhub_private.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbhub/usbhub_private.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -47,5 +47,5 @@
 #include <usb/usb.h>
 #include <usb/debug.h>
-#include <usb/request.h>
+#include <usb/dev/request.h>
 
 //************
Index: uspace/drv/usbmast/inquiry.c
===================================================================
--- uspace/drv/usbmast/inquiry.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbmast/inquiry.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -34,5 +34,5 @@
  * Main routines of USB mass storage driver.
  */
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 #include <usb/debug.h>
 #include <usb/classes/classes.h>
Index: uspace/drv/usbmast/main.c
===================================================================
--- uspace/drv/usbmast/main.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbmast/main.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -34,5 +34,5 @@
  * Main routines of USB mass storage driver.
  */
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 #include <usb/debug.h>
 #include <usb/classes/classes.h>
Index: uspace/drv/usbmast/mast.c
===================================================================
--- uspace/drv/usbmast/mast.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbmast/mast.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -40,5 +40,5 @@
 #include <str_error.h>
 #include <usb/debug.h>
-#include <usb/request.h>
+#include <usb/dev/request.h>
 
 bool usb_mast_verbose = true;
Index: uspace/drv/usbmast/mast.h
===================================================================
--- uspace/drv/usbmast/mast.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbmast/mast.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -39,6 +39,6 @@
 #include <sys/types.h>
 #include <usb/usb.h>
-#include <usb/pipes.h>
-#include <usb/devdrv.h>
+#include <usb/dev/pipes.h>
+#include <usb/dev/driver.h>
 
 /** Result of SCSI INQUIRY command.
Index: uspace/drv/usbmid/dump.c
===================================================================
--- uspace/drv/usbmid/dump.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbmid/dump.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -37,6 +37,6 @@
 #include <str_error.h>
 #include <stdlib.h>
-#include <usb/pipes.h>
-#include <usb/dp.h>
+#include <usb/dev/pipes.h>
+#include <usb/dev/dp.h>
 #include <usb/classes/classes.h>
 #include "usbmid.h"
Index: uspace/drv/usbmid/explore.c
===================================================================
--- uspace/drv/usbmid/explore.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbmid/explore.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -38,6 +38,6 @@
 #include <stdlib.h>
 #include <usb/classes/classes.h>
-#include <usb/request.h>
-#include <usb/dp.h>
+#include <usb/dev/request.h>
+#include <usb/dev/dp.h>
 #include <usb/ddfiface.h>
 #include "usbmid.h"
Index: uspace/drv/usbmid/main.c
===================================================================
--- uspace/drv/usbmid/main.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbmid/main.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -38,7 +38,7 @@
 #include <usb/debug.h>
 #include <usb/classes/classes.h>
-#include <usb/request.h>
+#include <usb/dev/request.h>
 #include <usb/descriptor.h>
-#include <usb/pipes.h>
+#include <usb/dev/pipes.h>
 
 #include "usbmid.h"
Index: uspace/drv/usbmid/usbmid.c
===================================================================
--- uspace/drv/usbmid/usbmid.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbmid/usbmid.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -39,7 +39,7 @@
 #include <usb_iface.h>
 #include <usb/ddfiface.h>
-#include <usb/pipes.h>
+#include <usb/dev/pipes.h>
 #include <usb/classes/classes.h>
-#include <usb/recognise.h>
+#include <usb/dev/recognise.h>
 #include "usbmid.h"
 
Index: uspace/drv/usbmid/usbmid.h
===================================================================
--- uspace/drv/usbmid/usbmid.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbmid/usbmid.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -40,7 +40,7 @@
 #include <ddf/driver.h>
 #include <usb/usb.h>
-#include <usb/pipes.h>
+#include <usb/dev/pipes.h>
 #include <usb/debug.h>
-#include <usb/devdrv.h>
+#include <usb/dev/driver.h>
 
 #define NAME "usbmid"
Index: uspace/drv/usbmouse/init.c
===================================================================
--- uspace/drv/usbmouse/init.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbmouse/init.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -37,6 +37,6 @@
 #include <usb/debug.h>
 #include <usb/classes/classes.h>
-#include <usb/classes/hid.h>
-#include <usb/request.h>
+#include <usb/hid/hid.h>
+#include <usb/dev/request.h>
 #include <errno.h>
 
Index: uspace/drv/usbmouse/main.c
===================================================================
--- uspace/drv/usbmouse/main.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbmouse/main.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -36,5 +36,5 @@
 #include "mouse.h"
 #include <usb/debug.h>
-#include <usb/devpoll.h>
+#include <usb/dev/poll.h>
 #include <errno.h>
 #include <str_error.h>
Index: uspace/drv/usbmouse/mouse.h
===================================================================
--- uspace/drv/usbmouse/mouse.h	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/usbmouse/mouse.h	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -37,6 +37,6 @@
 #define USBMOUSE_MOUSE_H_
 
-#include <usb/devdrv.h>
-#include <usb/pipes.h>
+#include <usb/dev/driver.h>
+#include <usb/dev/pipes.h>
 #include <time.h>
 
Index: uspace/drv/vhc/connhost.c
===================================================================
--- uspace/drv/vhc/connhost.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/vhc/connhost.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -36,5 +36,4 @@
 #include <errno.h>
 #include <usb/usb.h>
-#include <usb/addrkeep.h>
 #include <usb/ddfiface.h>
 #include <usb/debug.h>
Index: uspace/drv/vhc/hub.c
===================================================================
--- uspace/drv/vhc/hub.c	(revision d736fe38a9f7781f4f215851ebdd9bb698510061)
+++ uspace/drv/vhc/hub.c	(revision c7b582620681e6a7655a2fe435df4bb9bbac4977)
@@ -40,6 +40,6 @@
 #include <ddf/driver.h>
 #include <devman.h>
-#include <usb/hub.h>
-#include <usb/recognise.h>
+#include <usb/dev/hub.h>
+#include <usb/dev/recognise.h>
 
 #include "hub.h"
